Foxit PDF SDK

Public Types | Public Member Functions | Static Public Member Functions | List of all members
foxit.addon.layoutrecognition.LRStructureElement Class Reference
Inheritance diagram for foxit.addon.layoutrecognition.LRStructureElement:

## Public Types
enum | AttributeType { AttributeType.e_AttributeTypeInvalid = 0x0, AttributeType.e_AttributeTypeRole = 0x524f4c45, AttributeType.e_AttributeTypePlacement = 0x504c4143, AttributeType.e_AttributeTypeRotation = 0x524f5441, AttributeType.e_AttributeTypeWritingMode = 0x574d4f44, AttributeType.e_AttributeTypeDestination = 0x44455354, AttributeType.e_AttributeTypeBBox = 0x42424f58, AttributeType.e_AttributeTypeWidth = 0x57445448, AttributeType.e_AttributeTypeHeight = 0x48474854, AttributeType.e_AttributeTypeBackgroundColor = 0x424b4743, AttributeType.e_AttributeTypeBorderColor = 0x42445243, AttributeType.e_AttributeTypeBorderStyle = 0x42445253, AttributeType.e_AttributeTypeBorderThickness = 0x42445254, AttributeType.e_AttributeTypeAttached = 0x41545448, AttributeType.e_AttributeTypeSubType = 0x53554254, AttributeType.e_AttributeTypePadding = 0x50414447, AttributeType.e_AttributeTypeColor = 0x434f4c52, AttributeType.e_AttributeTypeSpaceBefore = 0x53504246, AttributeType.e_AttributeTypeSpaceAfter = 0x53504146, AttributeType.e_AttributeTypeStartIndent = 0x53494e44, AttributeType.e_AttributeTypeEndIndent = 0x45494e44, AttributeType.e_AttributeTypeTextIndent = 0x54494e44, AttributeType.e_AttributeTypeTextAlign = 0x54414c4e, AttributeType.e_AttributeTypeBlockAlign = 0x42414c4e, AttributeType.e_AttributeTypeInlineAlign = 0x49414c4e, AttributeType.e_AttributeTypeTBorderStyle = 0x54424453, AttributeType.e_AttributeTypeTPadding = 0x54504144, AttributeType.e_AttributeTypeBaselineShift = 0x42534846, AttributeType.e_AttributeTypeLineHeight = 0x4c484754, AttributeType.e_AttributeTypeTextDecorationColor = 0x5444434c, AttributeType.e_AttributeTypeTextDecorationThickness = 0x54445448, AttributeType.e_AttributeTypeTextDecorationType = 0x54445459, AttributeType.e_AttributeTypeRubyAlign = 0x5242414c, AttributeType.e_AttributeTypeRubyPosition = 0x52425053, AttributeType.e_AttributeTypeGlyphOrientationVertical = 0x474f5654, AttributeType.e_AttributeTypeColumnCount = 0x434c434e, AttributeType.e_AttributeTypeColumnGap = 0x434c4750, AttributeType.e_AttributeTypeColumnWidths = 0x434c5744, AttributeType.e_AttributeTypeListNumbering = 0x4c4e554d, AttributeType.e_AttributeTypeFieldRole = 0x46524f4c, AttributeType.e_AttributeTypeFieldChecked = 0x43484b44, AttributeType.e_AttributeTypeFieldDesc = 0x46445343, AttributeType.e_AttributeTypeRowSpan = 0x5253504e, AttributeType.e_AttributeTypeColSpan = 0x4353504e, AttributeType.e_AttributeTypeTableHeaders = 0x54484453, AttributeType.e_AttributeTypeTableHeaderScope = 0x54485343, AttributeType.e_AttributeTypeTableSummary = 0x5442534d, AttributeType.e_AttributeTypeShort = 0x53484f52, AttributeType.e_AttributeTypeDirection = 0x44495245, AttributeType.e_AttributeTypeABox = 0x414c4258, AttributeType.e_AttributeTypeVersion = 0x5645534e }
| Enumeration for element general layout attribute types. More...
enum | AttributeValueEnum { AttributeValueEnum.e_AttributeValueEnumInvalid = 0x0, AttributeValueEnum.e_AttributeValueEnumBlock = 0x424c434b, AttributeValueEnum.e_AttributeValueEnumInline = 0x494e4c4e, AttributeValueEnum.e_AttributeValueEnumWarichu = 0x57415249, AttributeValueEnum.e_AttributeValueEnumBefore = 0x42454652, AttributeValueEnum.e_AttributeValueEnumAfter = 0x41465445, AttributeValueEnum.e_AttributeValueEnumStart = 0x53545254, AttributeValueEnum.e_AttributeValueEnumEnd = 0x454e4400, AttributeValueEnum.e_AttributeValueEnumLrTb = 0x4c525442, AttributeValueEnum.e_AttributeValueEnumRlTb = 0x524c5442, AttributeValueEnum.e_AttributeValueEnumTbRl = 0x5442524c, AttributeValueEnum.e_AttributeValueEnumTbLr = 0x54424c52, AttributeValueEnum.e_AttributeValueEnumNone = 0x4e4f4e45, AttributeValueEnum.e_AttributeValueEnumHidden = 0x4849444e, AttributeValueEnum.e_AttributeValueEnumDotted = 0x444f5444, AttributeValueEnum.e_AttributeValueEnumDashed = 0x44534844, AttributeValueEnum.e_AttributeValueEnumSolid = 0x534f4c44, AttributeValueEnum.e_AttributeValueEnumDouble = 0x44424c45, AttributeValueEnum.e_AttributeValueEnumGroove = 0x41525459, AttributeValueEnum.e_AttributeValueEnumRidge = 0x52444745, AttributeValueEnum.e_AttributeValueEnumInset = 0x494e5354, AttributeValueEnum.e_AttributeValueEnumOutset = 0x4f545354 , AttributeValueEnum.e_AttributeValueEnumAuto = 0x4155544f, AttributeValueEnum.e_AttributeValueEnumCenter = 0x434e5452, AttributeValueEnum.e_AttributeValueEnumJustify = 0x4a535459, AttributeValueEnum.e_AttributeValueEnumMiddle = 0x4d49444c, AttributeValueEnum.e_AttributeValueEnumUnderline = 0x55444c4e, AttributeValueEnum.e_AttributeValueEnumOverline = 0x4f564c4e, AttributeValueEnum.e_AttributeValueEnumLineThrough = 0x4c4e5448, AttributeValueEnum.e_AttributeValueEnumDistribute = 0x44535442, AttributeValueEnum.e_AttributeValueEnumDisc = 0x44495343, AttributeValueEnum.e_AttributeValueEnumCircle = 0x4352434c, AttributeValueEnum.e_AttributeValueEnumSquare = 0x53515552, AttributeValueEnum.e_AttributeValueEnumDecimal = 0x44434d4c, AttributeValueEnum.e_AttributeValueEnumUpperRoman = 0x5550524d, AttributeValueEnum.e_AttributeValueEnumLowerRoman = 0x4c57524d, AttributeValueEnum.e_AttributeValueEnumUpperAlpha = 0x5550414c, AttributeValueEnum.e_AttributeValueEnumLowerAlpha = 0x4c57414c, AttributeValueEnum.e_AttributeValueEnumUnordered = 0x554e4f52, AttributeValueEnum.e_AttributeValueEnumOrdered = 0x4f524445, AttributeValueEnum.e_AttributeValueEnumFloat = 0x464c4f54, AttributeValueEnum.e_AttributeValueEnumRB = 0x52420000, AttributeValueEnum.e_AttributeValueEnumCB = 0x43420000, AttributeValueEnum.e_AttributeValueEnumPB = 0x50440000, AttributeValueEnum.e_AttributeValueEnumTV = 0x54560000, AttributeValueEnum.e_AttributeValueEnumOn = 0x4f4e0000, AttributeValueEnum.e_AttributeValueEnumOff = 0x4f464600, AttributeValueEnum.e_AttributeValueEnumNeutral = 0x4e555452, AttributeValueEnum.e_AttributeValueEnumRow = 0x524f5700, AttributeValueEnum.e_AttributeValueEnumColumn = 0x434c4d4e, AttributeValueEnum.e_AttributeValueEnumBoth = 0x424f5448, AttributeValueEnum.e_AttributeValueEnumLeft = 0x4c454654, AttributeValueEnum.e_AttributeValueEnumTop = 0x544f5000, AttributeValueEnum.e_AttributeValueEnumBottom = 0x42544f4d, AttributeValueEnum.e_AttributeValueEnumRight = 0x52474854, AttributeValueEnum.e_AttributeValueEnumPagination = 0x5041474e, AttributeValueEnum.e_AttributeValueEnumLayout = 0x4c41594f, AttributeValueEnum.e_AttributeValueEnumPage = 0x50414745, AttributeValueEnum.e_AttributeValueEnumBackground = 0x424b474e, AttributeValueEnum.e_AttributeValueEnumHeader = 0x48454144, AttributeValueEnum.e_AttributeValueEnumFooter = 0x464f4f54, AttributeValueEnum.e_AttributeValueEnumWatermark = 0x57544d4b, AttributeValueEnum.e_AttributeValueEnumPageNum = 0x504e554d, AttributeValueEnum.e_AttributeValueEnumBates = 0x42415445, AttributeValueEnum.e_AttributeValueEnumOther = 0x4f544845 }
| Enumeration for element general layout attribute enum values. More...
enum | AttributeValueType { AttributeValueType.e_AttributeValueTypeEmpty = 0x0, AttributeValueType.e_AttributeValueTypeEnum = 0x1, AttributeValueType.e_AttributeValueTypeInt32 = 0x2, AttributeValueType.e_AttributeValueTypeFloat = 0x3, AttributeValueType.e_AttributeValueTypeARGB = 0x4, AttributeValueType.e_AttributeValueTypeWStr = 0x5, AttributeValueType.e_AttributeValueTypeElement = 0x6, AttributeValueType.e_AttributeValueTypeEnumArray = 0x101, AttributeValueType.e_AttributeValueTypeInt32Array = 0x102, AttributeValueType.e_AttributeValueTypeFloatArray = 0x103, AttributeValueType.e_AttributeValueTypeARGBArray = 0x104, AttributeValueType.e_AttributeValueTypeWStrArray = 0x105, AttributeValueType.e_AttributeValueTypeElementArray = 0x106 }
| Enumeration for value type of element general layout attribute. More...
Public Types inherited from foxit.addon.layoutrecognition.LRElement
enum | ElementType : uint { ElementType.e_ElementTypeDocument = 0x0000, ElementType.e_ElementTypeDocumentFragment = 0x0001, ElementType.e_ElementTypePart = 0x0002, ElementType.e_ElementTypeArt = 0x0101, ElementType.e_ElementTypeSect = 0x0102, ElementType.e_ElementTypeDiv = 0x0100, ElementType.e_ElementTypeBlockQuote = 0x0103, ElementType.e_ElementTypeCaption = 0x0104, ElementType.e_ElementTypeTOC = 0x0105, ElementType.e_ElementTypeTOCI = 0x0106, ElementType.e_ElementTypeIndex = 0x0107, ElementType.e_ElementTypeAside = 0x0108, ElementType.e_ElementTypeTitle = 0x0109, ElementType.e_ElementTypeFENote = 0x010A, ElementType.e_ElementTypeNonStruct = 0x010F, ElementType.e_ElementTypePrivate = 0x0110, ElementType.e_ElementTypeParagraph = 0x0200, ElementType.e_ElementTypeHeading = 0x0201, ElementType.e_ElementTypeHeading1 = 0x0202, ElementType.e_ElementTypeHeading2 = 0x0203, ElementType.e_ElementTypeHeading3 = 0x0204, ElementType.e_ElementTypeHeading4 = 0x0205, ElementType.e_ElementTypeHeading5 = 0x0206, ElementType.e_ElementTypeHeading6 = 0x0207, ElementType.e_ElementTypeHeadingN = 0x0208, ElementType.e_ElementTypeList = 0x0209, ElementType.e_ElementTypeListItem = 0x020A, ElementType.e_ElementTypeListLabel = 0x020B, ElementType.e_ElementTypeListBody = 0x020C, ElementType.e_ElementTypeTable = 0x020D, ElementType.e_ElementTypeTableRow = 0x020E, ElementType.e_ElementTypeTableHeaderCell = 0x020F, ElementType.e_ElementTypeTableDataCell = 0x0210, ElementType.e_ElementTypeTableHeaderGroup = 0x0211, ElementType.e_ElementTypeTableBodyGroup = 0x0212, ElementType.e_ElementTypeTableFootGroup = 0x0213, ElementType.e_ElementTypeSpan = 0x0300, ElementType.e_ElementTypeQuote = 0x0301, ElementType.e_ElementTypeNote = 0x0302, ElementType.e_ElementTypeReference = 0x0303, ElementType.e_ElementTypeBibEntry = 0x0304, ElementType.e_ElementTypeCode = 0x0305, ElementType.e_ElementTypeLink = 0x0306, ElementType.e_ElementTypeAnnot = 0x0307, ElementType.e_ElementTypeRuby = 0x0308, ElementType.e_ElementTypeRubyBase = 0x0309, ElementType.e_ElementTypeRubyAnnot = 0x030A, ElementType.e_ElementTypeRubyPunc = 0x030B, ElementType.e_ElementTypeWarichu = 0x030C, ElementType.e_ElementTypeWarichuText = 0x030D, ElementType.e_ElementTypeWarichuPunc = 0x030E, ElementType.e_ElementTypeEm = 0x030F, ElementType.e_ElementTypeStrong = 0x0310, ElementType.e_ElementTypeSub = 0x0311, ElementType.e_ElementTypeFigure = 0x0400, ElementType.e_ElementTypeFormula = 0x0401, ElementType.e_ElementTypeForm = 0x0402, ElementType.e_ElementTypeArtifact = 0x1000, ElementType.e_ElementTypeTextObject = 0x80000001, ElementType.e_ElementTypePathObject = 0x80000002, ElementType.e_ElementTypeImageObject = 0x80000003, ElementType.e_ElementTypeShadingObject = 0x80000004, ElementType.e_ElementTypeFormObject = 0x80000005, ElementType.e_ElementTypeContainerObject = 0x8000000C, ElementType.e_ElementTypeAnnotObject = 0x8000000E, ElementType.e_ElementTypePageObject = 0x8000000F, ElementType.e_ElementTypeTextContent = 0xC0000001, ElementType.e_ElementTypePathContent = 0xC0000002, ElementType.e_ElementTypeImageContent = 0xC0000003, ElementType.e_ElementTypeShadingContent = 0xC0000004, ElementType.e_ElementTypeComplexContent = 0xC000000D, ElementType.e_ElementTypeAnnotContent = 0xC000000E }
| Enumeration for standard structure types. More...

## Public Member Functions
| LRStructureElement ()
| Constructor.
| LRStructureElement (LRStructureElement other)
| Constructor, with another structure element object. More...
| LRStructureElement (LRElement element)
| Constructor, with parent class object. More...
uint | GetAttributeValueARGB (LRStructureElement.AttributeType type, int index)
| Get an ARGB value (specified by index) for specified attribute type. More...
int | GetAttributeValueCount (LRStructureElement.AttributeType type)
| Get value count of a specified attribute type. More...
LRStructureElement | GetAttributeValueElement (LRStructureElement.AttributeType type, int index)
| Get an structure element object (specified by index) for specified attribute type. More...
LRStructureElement.AttributeValueEnum | GetAttributeValueEnum (LRStructureElement.AttributeType type, int index)
| Get an enum value (specified by index) for specified attribute type. More...
float | GetAttributeValueFloat (LRStructureElement.AttributeType type, int index)
| Get a float value (specified by index) for specified attribute type. More...
int | GetAttributeValueInt32 (LRStructureElement.AttributeType type, int index)
| Get an integer value (specified by index) for specified attribute type. More...
string | GetAttributeValueString (LRStructureElement.AttributeType type, int index)
| Get a string value (specified by index) for specified attribute type. More...
LRStructureElement.AttributeValueType | GetAttributeValueType (LRStructureElement.AttributeType type)
| Get attribute value type for a specified attribute type. More...
RectF | GetBBox ()
| Get bounding box. More...
LRElement | GetChild (int index)
| Get a child element by index. More...
int | GetChildCount ()
| Get the count of children elements. More...
LRStructureElement | GetParentElement ()
| Get the parent element. More...
LRStructureElement.AttributeType | GetSupportedAttribute (int index)
| Get a supported attribute type by index. More...
int | GetSupportedAttributeCount ()
| Get supported attribute count. More...
Public Member Functions inherited from foxit.addon.layoutrecognition.LRElement
| LRElement ()
| Constructor.
| LRElement (LRElement other)
| Constructor, with another base element object. More...
LRElement.ElementType | GetElementType ()
| Get element type. More...
bool | IsContentElement ()
| Check whether current object is content element or not. More...
bool | IsEmpty ()
| Check whether current object is empty or not. More...
bool | IsGraphicsObjectElement ()
| Check whether current object is graphics object element or not. More...
bool | IsStructureElement ()
| Check whether current object is structure element or not. More...
string | StringifyType ()
| Convert type (enum value) of current element to a short and memorable string (text) representation. More...

## Static Public Member Functions
static bool | IsArrayAttributeValueType (LRStructureElement.AttributeValueType type)
| Check whether input attribute value type represents an array. More...
static LRStructureElement.AttributeType | ParseAttributeType (string type_string)
| Parse a string representation for attribute type and retrieve the enum value for this attribute type. More...
static string | StringifyAttributeType (LRStructureElement.AttributeType type)
| Convert the enum value of a specified attribute type to a short and memorable string (text) representation. More...
static string | StringifyEnumVariant (LRStructureElement.AttributeValueEnum type)
| Convert the enum value of a specified attribute value enum to a short and memorable string (text) representation. More...
Static Public Member Functions inherited from foxit.addon.layoutrecognition.LRElement
static string | StringifyElementType (LRElement.ElementType type)
| Convert enum value of a specified element type to a short and memorable string (text) representation. More...

## Detailed Description

This class represents a structure element. A structure element can be used to construct a tree, like graphics structure element, paragraph structure element, span structure element and so on.

## Member Enumeration Documentation

## ◆ AttributeType

enum foxit.addon.layoutrecognition.LRStructureElement.AttributeType
| strong

Enumeration for element general layout attribute types.

Values of this enumeration should be used alone. For more details, please refer to "Layout Attributes" in <PDF reference 1.7> P916.

Enumerator
e_AttributeTypeInvalid | Attribute type: invalid.
e_AttributeTypeRole | Attribute type: role, which means strings of structure element meaning and standard type it maps to. Note Value type for this attribute type is string.
e_AttributeTypePlacement | Attribute type: Placement, which means the positioning of the element with respect to the enclosing reference area and other content. Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumBlock foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumInline foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumBefore foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumStart foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumEnd
e_AttributeTypeRotation | Attribute type: Rotation. Note Value type for this attribute type is number.
e_AttributeTypeWritingMode | Attribute type: WritingMode, which means the directions of layout progression for packing of ILSEs (inline progression) and stacking of BLSEs (block progression). Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumLrTb foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumRlTb foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumTbRl foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumTbLr (PDF 2.0)
e_AttributeTypeDestination | Attribute type: Destination (PDF 2.0), which provides a means to access content. Note Value type for this attribute type is an array of zero or stirngs with ID.
e_AttributeTypeBBox | Attribute type: BBox, which represents the element's bounding box (the rectangle that completely encloses its visible content). Note Value type for this attribute type is an array of four numbers in PDF coordinate system giving the coordinates of the left, bottom, right, and top edges of the elements's bounding box.
e_AttributeTypeWidth | Attribute type: Width, which represents the width of the element's content rectangle. Note Value type for this attribute type is number or enum value foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumAuto .
e_AttributeTypeHeight | Attribute type: Height, which represents the height of the element's content rectangle. Note Value type for this attribute type is number or enum value foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumAuto .
e_AttributeTypeBackgroundColor | Attribute type: BackgroundColor, which represents the color to be used to fill the background of a table cell or any element's content rectangle. Note Value type for this attribute type is RGB color.
e_AttributeTypeBorderColor | Attribute type: BorderColor, which represents the color of the border drawn on the edges of a table cell or any element's content rectangle. Note Value type for this attribute type is RGB color or an array of RGB color values.
e_AttributeTypeBorderStyle | Attribute type: BorderStyle, which represents the style of an element's border. Note Value type for this attribute type is enum or an array of enum values. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumNone foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumHidden foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumDotted foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumDashed foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumSolid foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumDouble foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumGroove foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumRidge foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumInset foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumOutset
e_AttributeTypeBorderThickness | Attribute type: BorderThickness, which represents the thickness of the border drawn on the edges of a table cell or any element's content rectangle. Note Value type for this attribute type is number (for all four edges) or an array of four numbers (for one edge of the border, in the order of the before, after, start, and end edge).
e_AttributeTypeAttached | Attribute type: Attached, which specifies the edges of the page, if any, to which the artifact is logically attached. Note Value type for this attribute type is an array of specified enum values. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumTop foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumLeft foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumBottom foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumRight
e_AttributeTypeSubType | Attribute type: Subtype, which means the subtype of annotation or artifact. Note Value type for this attribute type: For annotation, value type is string. For artifact, value type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumPagination foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumLayout foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumPage foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumBackground
e_AttributeTypePadding | Attribute type: Padding, which specifies an offset to account for the separation between the element's content rectangle and the surrounding border. Note Value type for this attribute type is number (for all four sides) or an array of four numbers (for the before, after, start, and end edge).
e_AttributeTypeColor | Attribute type: Color, which represents the color to be used for drawing text and the default value for the color of table borders and text decorations. Note Value type for this attribute type is RGB color.
e_AttributeTypeSpaceBefore | Attribute type: SpaceBefore, which represents the amount of extra space preceding the before edge of the BLSE. Note Value type for this attribute type is number.
e_AttributeTypeSpaceAfter | Attribute type: SpaceAfter, which represents the amount of extra space following the after edge of the BLSE. Note Value type for this attribute type is number.
e_AttributeTypeStartIndent | Attribute type: StartIndent, which represents the distance from the start edge of the reference area to that of the BLSE. Note Value type for this attribute type is number.
e_AttributeTypeEndIndent | Attribute type: EndIndent, which represents the distance from the end edge of the BLSE to that of the reference area. Note Value type for this attribute type is number.
e_AttributeTypeTextIndent | Attribute type: TextIndent, which represents the additional distance from the start edge of the BLSE, as specified by foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeStartIndent , to that of the first line of text. Note Value type for this attribute type is number.
e_AttributeTypeTextAlign | Attribute type: TextAlign, which represents the alignment of text and other content within lines of the BLSE. Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumStart foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumCenter foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumEnd foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumJustify
e_AttributeTypeBlockAlign | Attribute type: BlockAlign, which represents the alignment, in the block-progression direction, of content within the table cell. Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumBefore foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumCenter foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumAfter foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumJustify
e_AttributeTypeInlineAlign | Attribute type: InlineAlign, which represents the alignment, in the inline-progression direction, of content within the table cell. Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumStart foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumCenter foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumEnd
e_AttributeTypeTBorderStyle | Attribute type: TBorderStyle, which represents the style of the border drawn on each edge of a table cell. Note Value type for this attribute type is enum or an array of specified enum values. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumNone foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumHidden foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumDotted foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumDashed foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumSolid foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumDouble foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumGroove foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumRidge foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumInset foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumOutset
e_AttributeTypeTPadding | Attribute type: TPadding, which specifies an offset to account for the separation between the table cell's content rectangle and the surrounding border. Note Value type for this attribute type is number (for all four edges of the table cell) or an array of four numbers (for the before edge, after edge, start edge, and end edge of the content rectangle).
e_AttributeTypeBaselineShift | Attribute type: BaselineShift, which means the distance by which the element's baseline is shifted relative to that of its parent element. Note Value type for this attribute type is number.
e_AttributeTypeLineHeight | Attribute type: LineHeight, which means the element's preferred height, in the block-progression direction. Note Value type for this attribute type can be number or enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumNormal foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumAuto
e_AttributeTypeTextDecorationColor | Attribute type: TextDecorationColor, which represents the color to be used for drawing text decorations. Note Value type for this attribute type is RGB color.
e_AttributeTypeTextDecorationThickness | Attribute type: TextDecorationThickness, which represents the thickness of each line drawn as part of the text decoration. Note Value type for this attribute type is number.
e_AttributeTypeTextDecorationType | Attribute type: TextDecorationType, which represents the text decoration, if any, to be applied to the element's text. Note Value type for this attribute type is enum or an array of specified enum values. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumNone foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumUnderline foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumOverline foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumLineThrough
e_AttributeTypeRubyAlign | Attribute type: RubyAlign, which represents the justification of the lines within a ruby assembly. Note Value type for this attribute type is enum or an array of specified enum values. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumStart foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumCenter foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumEnd foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumJustify foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumDistribute
e_AttributeTypeRubyPosition | Attribute type: RubyPosition, which represents the placement of the RT structure element relative to the RB element in a ruby assembly. Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumBefore foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumAfter foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumWarichu foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumInline
e_AttributeTypeGlyphOrientationVertical | Attribute type: GlyphOrientationVertical, which specifies the orientation of glyphs when the inline-progression direction is top to bottom or bottom to top. Note Value type for this attribute type is number (which should be one of specified numbers -90, 0, 90, 180, and 270) or enum (which should be value foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumAuto ).
e_AttributeTypeColumnCount | Attribute type: ColumnCount, which represents the number of columns in the content of the grouping element. Note Value type for this attribute type is number.
e_AttributeTypeColumnGap | Attribute type: ColumnGap, which represents the desired space between adjacent columns, measured in the inline-progression direction. Note Value type for this attribute type can be number (for all columns) or an array of numbers. When the value type is array: if the array contains (ColumnCount-1) numbers, these numbers represent the space between the first and second columns, the second and third columns, and so on, respectively. if there are fewer than (ColumnCount-1) numbers, the last element specifies all remaining spaces; excess array elements are ignored.
e_AttributeTypeColumnWidths | Attribute type: ColumnWidths, which represents the desired width of the columns, measured in the inline-progression direction. Note Value type for this attribute type can be number (for all columns) or an array of numbers. When the value type is array: if the array contains ColumnCount numbers, these numbers represent the width of each column, in order. if there are fewer than ColumnCount numbers, the last element specifies all remaining widths; excess array elements are ignored.
e_AttributeTypeListNumbering | Attribute type only for List: ListNumbering, which represents the numbering system to be used to generate the content of the Lbl (Label) elements in an autonumbered list, or the symbol used to identify each item in an unnumbered list. Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumNone foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumDisc foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumCircle foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumSquare foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumDecimal foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumUpperRoman foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumLowerRoman foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumUpperAlpha foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumLowerAlpha foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumUnordered (PDF 2.0) foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumOrdered (PDF 2.0)
e_AttributeTypeFieldRole | Attribute type only for PrintField: Role, which represents the type of form field represented by this graphic. Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumRB foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumCB foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumPB foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumTV
e_AttributeTypeFieldChecked | Attribute type only for PrintField: checked, which represents the state of a radio button or check box field. Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumOn foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumOff foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumNeutral
e_AttributeTypeFieldDesc | Attribute type only for PrintField: Desc, which represents the alternate name of the field, similar to the value supplied in the TU entry of the field dictionary for interactive fields. Note Value type for this attribute type is string.
e_AttributeTypeRowSpan | Attribute type only for Table: RowSpan, which represents the number of rows in the enclosing table that are spanned by the cell. Note Value type for this attribute type is number.
e_AttributeTypeColSpan | Attribute type only for Table: ColSpan, which represents the number of columns in the enclosing table that are spanned by the cell. Note Value type for this attribute type is number.
e_AttributeTypeTableHeaders | (Currently, unsupported) Attribute type only for Table: Headers, which represents an array of element identifiers. Note Value type for this attribute type is an array of strings.
e_AttributeTypeTableHeaderScope | Attribute type only for Table: Scope, which indicates whether the header cell applies to the rest of the cells in the row that contains it, the column that contains it, or both the row and the column that contain it. Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumRow foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumColumn foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumBoth
e_AttributeTypeTableSummary | Attribute type only for Table: Summary, which represents a summary of the table's purpose and structure, for use in non-visual rendering such as speech or braille. Note Value type for this attribute type is string.
e_AttributeTypeShort | Attribute type: Short (PDF 2.0), which contains a short form of the content of a TH structure element's content. Note Value type for this attribute type is string.
e_AttributeTypeDirection | (Reserved) Attribute type: Direction. Note Value type for this attribute type is enum. Valid enum values are: foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumStart foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumEnd foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumBefore foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumAfter foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumOther (PDF 2.0)
e_AttributeTypeABox | (Reserved) Attribute type: ABox. Note Value type for this attribute type is an array of four numbers.
e_AttributeTypeVersion | (Reserved) Attribute type: Version, which represents schema version of layout recognition engine. Note Value type for this attribute type is number.

## ◆ AttributeValueEnum

enum foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum
| strong

Enumeration for element general layout attribute enum values.

Values of this enumeration should be used alone. This is the set of enum values for all attribute types whose value types are enum or an array of enum values.

Enumerator
e_AttributeValueEnumInvalid | Invalid enum value.
e_AttributeValueEnumBlock | Enum value: Block, which means to be stacked in the block-progression direction within an enclosing reference area or parent BLSE. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypePlacement .
e_AttributeValueEnumInline | Enum value: Inline, which means the placement for attributes Placement/RubyPosition. For attribute Placement, this means to be packed in the inline-progression direction within an enclosing BLSE. For attribute RubyPosition, this means that the RT and associated RP elements are to be formatted as a parenthesis comment, following the RB element Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypePlacement , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRubyPosition .
e_AttributeValueEnumWarichu | Enum value: Warichu, which means the RT and associated RP elements are to be formatted as a warichu, following the RB element. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRubyPosition .
e_AttributeValueEnumBefore | Enum value: Before, which means the placement for attributes Placement/RubyPosition or alignment for attribute BlockAlign. For attribute Placement, this means to be placed so that the before edge of the element's allocation rectangle coincides with that of the nearest enclosing reference area. For attribute BlockAlign, this means before edge of the first child's allocation rectangle aligned with that of the table cell's content rectangle. For attribute RubyPosition, this means the placement of the RT structure element relative to the RB element in a ruby assembly. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypePlacement , foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBlockAlign , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRubyPosition .
e_AttributeValueEnumAfter | Enum value: After, which means the alignment for attribute BlockAlign or the placement for attribute RubyPosition. For attribute BlockAlign, this means after edge of the last child's allocation rectangle aligned with that of the table cell's content rectangle. For attribute RubyPosition, this means the RT content is to be aligned along the after edge of the element. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBlockAlign , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRubyPosition .
e_AttributeValueEnumStart | Enum value: Start, which means the place for attribute Placement, or the alignment for attributes TextAlign/InlineAlign/RubyAlign. For attribute Placement, this means to be placed so that the start edge of the element's allocation rectangle coincides with that of the nearest enclosing reference area. For attribute TextAlign, this means to be aligned with the start edge. For attribute InlineAlign, this means start edge of each child's allocation rectangle aligned with that of the table cell's content rectangle. For attribute RubyAlign, this means that the content is to be aligned on the start edge in the inlineprogression direction. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypePlacement , foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTextAlign , foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeInlineAlign , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRubyAlign .
e_AttributeValueEnumEnd | Enum value: End, which means the place for attribute Placement, or the alignment for attributes TextAlign/InlineAlign/RubyAlign. For attribute Placement, this means to be placed so that the end edge of the element's allocation rectangle coincides with that of the nearest enclosing reference area. For attribute TextAlign, this means to be aligned with the end edge. For attribute InlineAlign, this means end edge of each child's allocation rectangle aligned with that of the table cell's content rectangle. For attribute RubyAlign, this means that the content is to be aligned on the end edge in the inlineprogression direction. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypePlacement , foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTextAlign , foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeInlineAlign , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRubyAlign .
e_AttributeValueEnumLrTb | Enum value: LtTb, which means inline progression from left to right; block progression from top to bottom. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeWritingMode .
e_AttributeValueEnumRlTb | Enum value: RlTb, which means inline progression from right to left; block progression from top to bottom. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeWritingMode .
e_AttributeValueEnumTbRl | Enum value: TbRl, which means inline progression from top to bottom; block progression from right to left. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeWritingMode .
e_AttributeValueEnumTbLr | Enum value: TbLr (PDF 2.0), which means inline progression from top to bottom; block progression from left to right. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeWritingMode .
e_AttributeValueEnumNone | Enum value: None, which means no such attribute. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBorderStyle , foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTBorderStyle , .* foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTextDecorationType , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumHidden | Enum value: Hidden, which is same as None except in terms of border conflict resolution for table elements. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBorderStyle , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTBorderStyle .
e_AttributeValueEnumDotted | Enum value: Dotten, which means the border is a series of dots. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBorderStyle , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTBorderStyle .
e_AttributeValueEnumDashed | Enum value: Dashed, which means the border is a series of short line segments. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBorderStyle , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTBorderStyle .
e_AttributeValueEnumSolid | Enum value: Solid, which means the border is a single line segment. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBorderStyle , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTBorderStyle .
e_AttributeValueEnumDouble | Enum value: Double, which means the border is two solid lines. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBorderStyle , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTBorderStyle .
e_AttributeValueEnumGroove | Enum value: Groove, which means the border looks as though it were carved into the canvas. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBorderStyle , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTBorderStyle .
e_AttributeValueEnumRidge | Enum value: Ridge, which means the border looks as though it were coming out of the canvas (the opposite of Groove). Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBorderStyle , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTBorderStyle .
e_AttributeValueEnumInset | Enum value: Inset, which means the border makes the entire box look as though it were embedded in the canvas. Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBorderStyle , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTBorderStyle .
e_AttributeValueEnumOutset | Enum value: Outset, which means the border makes the entire box look as though it were coming out of the canvas (the opposite of Inset). Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBorderStyle , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTBorderStyle .
e_AttributeValueEnumAuto | Enum value: Auto. For attribute Width and Height, this indicates that no specific value and the value will be determined automatically. For attribute LineHeight, this means not to adjust for the value of BaselineShift. For attribute GlyphOrientationVertical, this specifies a default orientation for text depending on whether it is fullwidth(as wide as it is high). Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeWidth , foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeHeight , foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeLineHeight , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeGlyphOrientationVertical .
e_AttributeValueEnumCenter | Enum value: Center, which means the alignment for attributes TextAlign/InlineAlign/RubyAlign. For attribute TextAlign, this means to be centered between the start and end edges. For attribute InlineAlign, this means that each child centered within the table cell. For attribute RubyAlign, this means that the content is to be centered in the inline-progression direction Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTextAlign , foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeInlineAlign , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRubyAlign .
e_AttributeValueEnumJustify | Enum value: Justify, which means the alignment for attributes TextAlign/BlockAlign/RubyAlign. For attribute TextAlign, this means to be aligned with both the start and end edges, with internal spacing within each line expanded, if necessary, to achieve such alignment. For attribute BlockAlign, this means that children are aligned with both the before and after edges of the table cell's content rectangle. For attribute RubyAlign, this means that the content is to be centered in the inline-progression direction Note This can be used with attribute types foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTextAlign , foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBlockAlign , and foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRubyAlign .
e_AttributeValueEnumMiddle | Enum value: Middle, which means children are centered within the table cell. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeBlockAlign .
e_AttributeValueEnumUnderline | Enum value: Underline, which means a line below the text. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTextDecorationType .
e_AttributeValueEnumOverline | Enum value: Overline, which means a line above the text. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTextDecorationType .
e_AttributeValueEnumLineThrough | Enum value: LineThrough, which means a line through the middle of the text. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTextDecorationType .
e_AttributeValueEnumDistribute | Enum value: Distribute, which means the content is to be expanded to fill the available width in the inline-progression direction. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRubyAlign .
e_AttributeValueEnumDisc | Enum value: Disc, which means solid circular bullet. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumCircle | Enum value: Circle, which means open circular bullet. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumSquare | Enum value: Square, which means solid square bullet. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumDecimal | Enum value: Decimal, which means decimal arabic numerals (1-9, 10-99, ...). Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumUpperRoman | Enum value: UpperRoman, which means uppercase roman numerals (I, II, III, IV, ...). Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumLowerRoman | Enum value: LowerRoman, which means lowercase roman numerals (i, ii, iii, iv, ...). Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumUpperAlpha | Enum value: UpperAlpha, which means uppercase letters (A, B, C, ...). Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumLowerAlpha | Enum value: LowerAlpha, which means lowercase letters (a, b, c, ...). Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumUnordered | Enum value: Unordered (PDF 2.0), which means unordered list with unspecified bullets. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumOrdered | Enum value: Ordered (PDF 2.0), which means ordered lists with unspecified numbering. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeListNumbering .
e_AttributeValueEnumFloat | Enum value: float.
e_AttributeValueEnumRB | Enum value: rb, which means radio button. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeFieldRole .
e_AttributeValueEnumCB | Enum value: cb, which means check box. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeFieldRole .
e_AttributeValueEnumPB | Enum value: pb, which means push button. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeFieldRole .
e_AttributeValueEnumTV | Enum value: tv, which means text-value field. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeFieldRole .
e_AttributeValueEnumOn | Enum value: on, which means the state is on. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeFieldChecked .
e_AttributeValueEnumOff | Enum value: off, which means the state is off. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeFieldChecked .
e_AttributeValueEnumNeutral | Enum value: neutral, which means the state is neutral. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeFieldChecked .
e_AttributeValueEnumRow | Enum value: Row, which means row of a table. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTableHeaderScope .
e_AttributeValueEnumColumn | Enum value: Row, which means column of a table. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTableHeaderScope .
e_AttributeValueEnumBoth | Enum value: Row, which means both row and column of a table. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeTableHeaderScope .
e_AttributeValueEnumLeft | Enum value: Left, which means left edge of the page. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeAttached .
e_AttributeValueEnumTop | Enum value: Top, which means top edge of the page. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeAttached .
e_AttributeValueEnumBottom | Enum value: Bottom, which means bottom edge of the page. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeAttached .
e_AttributeValueEnumRight | Enum value: Right, which means right edge of the page. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeAttached .
e_AttributeValueEnumPagination | Enum value: Pagination, which means pagination artifacts. Ancillary page features such as running heads and folios (page numbers). Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeSubType .
e_AttributeValueEnumLayout | Enum value: Layout, which means layout artifacts. Purely cosmetic typographical or design elements such as footnote rules or background screens. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeSubType .
e_AttributeValueEnumPage | Enum value: Page, which means page artifacts. Production aids extraneous to the document itself, such as cut marks and color bars. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeSubType .
e_AttributeValueEnumBackground | Enum value: Background, which means background artifacts. Background artifacts typically serve as a background for content shown either on top of or placed adjacent to that background. Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeSubType .
e_AttributeValueEnumHeader | Enum value: Header.
e_AttributeValueEnumFooter | Enum value: Footer.
e_AttributeValueEnumWatermark | Enum value: Watermark.
e_AttributeValueEnumPageNum | Enum value: PageNum (PDF2.0).
e_AttributeValueEnumBates | Enum value: Bates (PDF2.0).
e_AttributeValueEnumOther | Enum value: Other (PDF 2.0). Note This can be used with attribute type foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeDirection .

## ◆ AttributeValueType

enum foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType
| strong

Enumeration for value type of element general layout attribute.

Values of this enumeration should be used alone.

Enumerator
e_AttributeValueTypeEmpty | Empty value type.
e_AttributeValueTypeEnum | Value type: enum.
e_AttributeValueTypeInt32 | Value type: 32-bit signed integer.
e_AttributeValueTypeFloat | Value type: float.
e_AttributeValueTypeARGB | Value type: ARGB color type, 32 bits, ((b) | ((g) << 8) | ((r) << 16)) | ((a) << 24).
e_AttributeValueTypeWStr | Value type: wide string.
e_AttributeValueTypeElement | Value type: element.
e_AttributeValueTypeEnumArray | Value type: an array of enum values.
e_AttributeValueTypeInt32Array | Value type: an array of integer values.
e_AttributeValueTypeFloatArray | Value type: an array of float values.
e_AttributeValueTypeARGBArray | Value type: an array of ARGB values.
e_AttributeValueTypeWStrArray | Value type: an array of wide strings.
e_AttributeValueTypeElementArray | Value type: an array of elements.

## Constructor & Destructor Documentation

## ◆ LRStructureElement() [1/2]

foxit.addon.layoutrecognition.LRStructureElement.LRStructureElement | ( | LRStructureElement | other | ) |
| inline

Constructor, with another structure element object.

Parameters

  [in] | other | Another structure element object.

## ◆ LRStructureElement() [2/2]

foxit.addon.layoutrecognition.LRStructureElement.LRStructureElement | ( | LRElement | element | ) |
| inline

Constructor, with parent class object.

Parameters

  [in] | element | Parent class object.

## Member Function Documentation

## ◆ GetAttributeValueARGB()

uint foxit.addon.layoutrecognition.LRStructureElement.GetAttributeValueARGB | ( | LRStructureElement.AttributeType | type,
|  | int | index
| ) |  |
| inline

Get an ARGB value (specified by index) for specified attribute type.

This function is available for attributes whose value type is foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeARGB or foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeARGBArray . For other value type, this function will return 0.

Parameters

  [in] | type | Attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRole and this should be one of these values.
  [in] | index | Index to specify which value will be retrieved. Valid range: from 0 to (count-1). count is returned by function LRStructureElement.GetAttributeValueCount .

Returns
  ARGB value.

## ◆ GetAttributeValueCount()

int foxit.addon.layoutrecognition.LRStructureElement.GetAttributeValueCount | ( | LRStructureElement.AttributeType | type | ) |
| inline

Get value count of a specified attribute type.

- When the value type of an attribute type represents an array, this function returns the size of the array.

- When the value type of an attribute type does not represent an array, this function will alway return 1.

Parameters

  [in] | type | Attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRole and this should be one of these values.

Returns
  Value count of a specified attribute type.

## ◆ GetAttributeValueElement()

LRStructureElement foxit.addon.layoutrecognition.LRStructureElement.GetAttributeValueElement | ( | LRStructureElement.AttributeType | type,
|  | int | index
| ) |  |
| inline

Get an structure element object (specified by index) for specified attribute type.

This function is available for attributes whose value type is foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeElement or foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeElementArray . For other value type, this function will return a structure element whose function LRStructureElement::IsEmpty returns true.

Parameters

  [in] | type | Attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRole and this should be one of these values.
  [in] | index | Index to specify which value will be retrieved. Valid range: from 0 to (count-1). count is returned by function LRStructureElement.GetAttributeValueCount .

Returns
  A structure element.

## ◆ GetAttributeValueEnum()

LRStructureElement.AttributeValueEnum foxit.addon.layoutrecognition.LRStructureElement.GetAttributeValueEnum | ( | LRStructureElement.AttributeType | type,
|  | int | index
| ) |  |
| inline

Get an enum value (specified by index) for specified attribute type.

This function is available for attributes whose value type is foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeEnum or foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeEnumArray . For other value type, this function will return foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumInvalid .

Parameters

  [in] | type | Attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRole and this should be one of these values.
  [in] | index | Index to specify which value will be retrieved. Valid range: from 0 to (count-1). count is returned by function LRStructureElement.GetAttributeValueCount .

Returns
  An enum value. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumInvalid and this would be one of these values.

## ◆ GetAttributeValueFloat()

float foxit.addon.layoutrecognition.LRStructureElement.GetAttributeValueFloat | ( | LRStructureElement.AttributeType | type,
|  | int | index
| ) |  |
| inline

Get a float value (specified by index) for specified attribute type.

This function is available for attributes whose value type is foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeFloat or foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeFloatArray . For other value type, this function will return 0.0.

Parameters

  [in] | type | Attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRole and this should be one of these values.
  [in] | index | Index to specify which value will be retrieved. Valid range: from 0 to (count-1). count is returned by function LRStructureElement.GetAttributeValueCount .

Returns
  Float value.

## ◆ GetAttributeValueInt32()

int foxit.addon.layoutrecognition.LRStructureElement.GetAttributeValueInt32 | ( | LRStructureElement.AttributeType | type,
|  | int | index
| ) |  |
| inline

Get an integer value (specified by index) for specified attribute type.

This function is available for attributes whose value type is foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeInt32 or foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeInt32Array . For other value type, this function will return 0.

Parameters

  [in] | type | Attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRole and this should be one of these values.
  [in] | index | Index to specify which value will be retrieved. Valid range: from 0 to (count-1). count is returned by function LRStructureElement.GetAttributeValueCount .

Returns
  Integer value.

## ◆ GetAttributeValueString()

string foxit.addon.layoutrecognition.LRStructureElement.GetAttributeValueString | ( | LRStructureElement.AttributeType | type,
|  | int | index
| ) |  |
| inline

Get a string value (specified by index) for specified attribute type.

This function is available for attributes whose value type is foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeWStr or foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeWStrArray . For other value type, this function will return an empty string.

Parameters

  [in] | type | Attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRole and this should be one of these values.
  [in] | index | Index to specify which value will be retrieved. Valid range: from 0 to (count-1). count is returned by function LRStructureElement.GetAttributeValueCount .

Returns
  Wide string value.

## ◆ GetAttributeValueType()

LRStructureElement.AttributeValueType foxit.addon.layoutrecognition.LRStructureElement.GetAttributeValueType | ( | LRStructureElement.AttributeType | type | ) |
| inline

Get attribute value type for a specified attribute type.

Parameters

  [in] | type | Attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeRole and this should be one of these values.

Returns
  Value type for the specified attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeEmpty and this would be one of these values.

## ◆ GetBBox()

RectF foxit.addon.layoutrecognition.LRStructureElement.GetBBox | ( |  | ) |
| inline

Get bounding box.

Returns
  Bounding box.

## ◆ GetChild()

LRElement foxit.addon.layoutrecognition.LRStructureElement.GetChild | ( | int | index | ) |
| inline

Get a child element by index.

Parameters

  [in] | index | Index of a child element to be retrieved. Valid range: from 0 to (count-1). count is returned by function LRStructureElement.GetChildCount .

Returns
  A child element.

## ◆ GetChildCount()

int foxit.addon.layoutrecognition.LRStructureElement.GetChildCount | ( |  | ) |
| inline

Get the count of children elements.

Returns
  Count of children elements.

## ◆ GetParentElement()

LRStructureElement foxit.addon.layoutrecognition.LRStructureElement.GetParentElement | ( |  | ) |
| inline

Get the parent element.

Returns
  Parent element. If function LRStructureElement::IsEmpty for the returned object returns true, that means current element does not have a parent element.

## ◆ GetSupportedAttribute()

LRStructureElement.AttributeType foxit.addon.layoutrecognition.LRStructureElement.GetSupportedAttribute | ( | int | index | ) |
| inline

Get a supported attribute type by index.

Parameters

  [in] | index | Index for a supported attribute whose type is to be retrieved. Valid range: from 0 to (count-1). count is returned by function LRStructureElement.GetSupportedAttributeCount .

Returns
  Attribute type of the attribute specified by index.

## ◆ GetSupportedAttributeCount()

int foxit.addon.layoutrecognition.LRStructureElement.GetSupportedAttributeCount | ( |  | ) |
| inline

Get supported attribute count.

Returns
  Count of supported attribute.

## ◆ IsArrayAttributeValueType()

static bool foxit.addon.layoutrecognition.LRStructureElement.IsArrayAttributeValueType | ( | LRStructureElement.AttributeValueType | type | ) |
| inline static

Check whether input attribute value type represents an array.

Parameters

  [in] | type | Attribute value type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeValueType.e_AttributeValueTypeEmpty and this should be one of these values.

Returns
  true means input type represents an array, while false means input type does not represent an array.

## ◆ ParseAttributeType()

static LRStructureElement.AttributeType foxit.addon.layoutrecognition.LRStructureElement.ParseAttributeType | ( | string | type_string | ) |
| inline static

Parse a string representation for attribute type and retrieve the enum value for this attribute type.

Parameters

  [in] | type_string | A string representation for a structure element attribute type.

Returns
  Enum value for attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeInvalid and this would be one of these values.

## ◆ StringifyAttributeType()

static string foxit.addon.layoutrecognition.LRStructureElement.StringifyAttributeType | ( | LRStructureElement.AttributeType | type | ) |
| inline static

Convert the enum value of a specified attribute type to a short and memorable string (text) representation.

Parameters

  [in] | type | Enum value of a specified attribute type. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeInvalid and this should be one of these values.

Returns
  A string that represents the short and memorable string representation for specified type. If there is no short and memorable string representation, or input type is foxit.addon.layoutrecognition.LRStructureElement.AttributeType.e_AttributeTypeInvalid or an invalid enum value, this function would return an empty string.

## ◆ StringifyEnumVariant()

static string foxit.addon.layoutrecognition.LRStructureElement.StringifyEnumVariant | ( | LRStructureElement.AttributeValueEnum | type | ) |
| inline static

Convert the enum value of a specified attribute value enum to a short and memorable string (text) representation.

Parameters

  [in] | type | Enum value of a specified attribute value enum. Please refer to values starting from foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumInvalid and this should be one of these values.

Returns
  A string that represents the short and memorable string representation for specified enum. If there is no short and memorable string representation, or input enum value is foxit.addon.layoutrecognition.LRStructureElement.AttributeValueEnum.e_AttributeValueEnumInvalid or an invalid enum value, this function would return an empty string.